
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \fileBarAttributes.h
    \brief Definition of Bar Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/


#ifndef BarWrapper_H
#define BarWrapper_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



#include "Bar.h"



#include "GraphWrapper.h"






#include "GraphShadeWrapper.h"


namespace magics {

class MagRequest;


class BarWrapper: public GraphWrapper

{
public:
//  --  constructor
    BarWrapper();
    BarWrapper(Bar*);
//  --  destructor
    virtual ~BarWrapper();
    virtual void set(const MagRequest&);

    Bar* me()   { return bar_; }

   	virtual Bar* object() { return bar_; }


	virtual void object(Bar* o) {
		// Remember to delete the previous object
		bar_ = o;
		GraphWrapper::object(o);
		

	}



protected:
    Bar* bar_;


//  --  method
	virtual void print(ostream&) const;


private:
    string tag_;
	friend ostream& operator<<(ostream& s,const BarWrapper& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif