
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \fileGribLoopAttributes.h
    \brief Definition of GribLoop Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/


#ifndef GribLoopWrapper_H
#define GribLoopWrapper_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



#include "GribDecoder.h"








#include "GribAddressModeWrapper.h"
#include "GribLoopStepWrapper.h"
#include "WindModeWrapper.h"


namespace magics {

class MagRequest;



class GribLoopWrapper

{
public:
//  --  constructor
    GribLoopWrapper();
    GribLoopWrapper(GribLoop*);
//  --  destructor
    virtual ~GribLoopWrapper();
    virtual void set(const MagRequest&);

    GribLoop* me()   { return gribloop_; }

   	virtual GribLoop* object() { return gribloop_; }


	virtual void object(GribLoop* o) {
		// Remember to delete the previous object
		gribloop_ = o;
		

	}



protected:
    GribLoop* gribloop_;


//  --  method
	virtual void print(ostream&) const;


private:
    string tag_;
	friend ostream& operator<<(ostream& s,const GribLoopWrapper& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif