
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \fileIsoShadingAttributes.h
    \brief Definition of IsoShading Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/


#ifndef IsoShadingWrapper_H
#define IsoShadingWrapper_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



#include "IsoShading.h"



#include "NoIsoShadingWrapper.h"






#include "ShadingTechniqueWrapper.h"
#include "ColourTechniqueWrapper.h"


namespace magics {

class MagRequest;


class IsoShadingWrapper: public NoIsoShadingWrapper

{
public:
//  --  constructor
    IsoShadingWrapper();
    IsoShadingWrapper(IsoShading*);
//  --  destructor
    virtual ~IsoShadingWrapper();
    virtual void set(const MagRequest&);

    IsoShading* me()   { return isoshading_; }

   	virtual IsoShading* object() { return isoshading_; }


	virtual void object(IsoShading* o) {
		// Remember to delete the previous object
		isoshading_ = o;
		NoIsoShadingWrapper::object(o);
		

	}



protected:
    IsoShading* isoshading_;


//  --  method
	virtual void print(ostream&) const;


private:
    string tag_;
	friend ostream& operator<<(ostream& s,const IsoShadingWrapper& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif