
/******************************  LICENSE  *******************************

 * (C) Copyright 1996-2017 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \\file ObsJSonAttributes.h
    \\brief Definition of ObsJSon Attributes class.

    This file is automatically generated.
    Do Not Edit!

*/

#include "MagRequest.h"
#include "ObsJSonWrapper.h"
#include "MagicsParameter.h"
#include "Factory.h"
#include "MagTranslator.h"
#include "MagicsGlobal.h"

using namespace magics;



ObsJSonWrapper::ObsJSonWrapper(): obsjson_(new ObsJSon())


{


	

}
ObsJSonWrapper::ObsJSonWrapper(ObsJSon* obsjson): obsjson_(obsjson)
{

	
}

ObsJSonWrapper::~ObsJSonWrapper()
{

}

void ObsJSonWrapper::set(const MagRequest& request)
{

	

	if  (request.countValues("OBSJSON_INPUT_FILENAME") ) {
		string path_value = request("OBSJSON_INPUT_FILENAME");
		obsjson_->path_ = path_value;
		}
	stringarray  values_value;
	for (int i = 0; i < request.countValues("OBSJSON_INFO_LIST"); i++)
		values_value.push_back((string)request("OBSJSON_INFO_LIST", i));
	if ( !values_value.empty() )
		obsjson_->values_ = values_value;
	
	
}

void ObsJSonWrapper::print(ostream& out)  const
{
	out << "ObsJSonWrapper[]";
}


