
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \filePageIDAttributes.h
    \brief Definition of PageID Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/


#ifndef PageIDWrapper_H
#define PageIDWrapper_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



#include "PageID.h"



#include "NoPageIDWrapper.h"






#include "NoLogoPlottingWrapper.h"


namespace magics {

class MagRequest;


class PageIDWrapper: public NoPageIDWrapper

{
public:
//  --  constructor
    PageIDWrapper();
    PageIDWrapper(PageID*);
//  --  destructor
    virtual ~PageIDWrapper();
    virtual void set(const MagRequest&);

    PageID* me()   { return pageid_; }

   	virtual PageID* object() { return pageid_; }


	virtual void object(PageID* o) {
		// Remember to delete the previous object
		pageid_ = o;
		NoPageIDWrapper::object(o);
		

	}



protected:
    PageID* pageid_;


//  --  method
	virtual void print(ostream&) const;


private:
    string tag_;
	friend ostream& operator<<(ostream& s,const PageIDWrapper& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif