
/*******************************  LICENSE  *******************************

 * (C) Copyright 1996-2016 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.

 *******************************  LICENSE  *******************************/

/*! \fileTaylorProjectionAttributes.h
    \brief Definition of TaylorProjection Attributes class.

    This file is automatically generated.
    Do Not Edit!

    Generated: 
*/


#ifndef TaylorProjectionWrapper_H
#define TaylorProjectionWrapper_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



#include "TaylorProjection.h"



#include "TransformationWrapper.h"








namespace magics {

class MagRequest;


class TaylorProjectionWrapper: public TransformationWrapper

{
public:
//  --  constructor
    TaylorProjectionWrapper();
    TaylorProjectionWrapper(TaylorProjection*);
//  --  destructor
    virtual ~TaylorProjectionWrapper();
    virtual void set(const MagRequest&);

    TaylorProjection* me()   { return taylorprojection_; }

   	virtual TaylorProjection* object() { return taylorprojection_; }


	virtual void object(TaylorProjection* o) {
		// Remember to delete the previous object
		taylorprojection_ = o;
		TransformationWrapper::object(o);
		

	}



protected:
    TaylorProjection* taylorprojection_;


//  --  method
	virtual void print(ostream&) const;


private:
    string tag_;
	friend ostream& operator<<(ostream& s,const TaylorProjectionWrapper& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif